'=============      INI   =================
' :              
' :          1.2 (28.03.2011 - 29.08.2011)
' Mail:                 Averin-And@yandex.ru
' Site:                  http://tc-image.3dn.ru
'========================================================================
Set FSO = CreateObject("Scripting.FileSystemObject")
'====================      =================================
' ReadINI(n, FileName, [Section], [Key], [Value], [Default])
'        INI
'=======================     =====================================
' 1- : n -  .   :
'        1   -     Key
'        10 -    Key   (Key=Value)
'        11 -     ,     [Section].    , e     ,    Key = "1,2,3..."
'        12 -  ,   11,      (Key=Value)
'        13 -    ,     [Section]
'        14 -  ,   13,      (Key=Value)
'        15 -        [Section]
'        16 -  ,   15,      (Key=Value)
'        17 -    ,      Section (.. ,   )
'        2   -      [Section]
'        21  -      [Section]  
'        3   -         c [ ]
'        31 -          [ ]
'        4   -     ,    Value   [Section]
'        40 -          [Section].    ,        ,    Value = "1,2,3..."
'        41 -   1- ,   Value   [Section]
'        42 -   2- ,   Value   [Section]
'        ...
'        60 -   20- ,   Value   [Section]
'        (   -  )
' 2- : FileName  -  \_.ini (   )
'                                               -     ini  ( ,   )
' 3- : Section  -     INI 
' 4- : Key  -    
' 5- : Value  -   
' 6- : Default  -  ,   , :
'                            -   
'                            -     (  3)
'                            -    ( 1)
'                            -     (  )
'========================      =====================================
' Call AkelPad.Include("FunctionsIni.vbs")
' Value = ReadINI(1, "c:\Name.ini", "Lister", "Caret", "", "")  -     Caret   [Lister]
' Value = ReadINI(1, "c:\Name.ini", "Lister", "Caret", "", "")  -     Caret   [Lister] (  , ,  -   "")
' ListKey = ReadINI(11, "c:\Name.ini", "Configuration", "Copy,Icon,Win", "", "")  -          [Configuration].    , e   Copy  Icon  Win
' ListKey = ReadINI(12, "c:\Name.ini", "General", "", "", "")  -    ,     [General]
' ListValue = ReadINI(13, "c:\Name.ini", "General", "", "", "")  -    ,      [General]
' ListKey = ReadINI(14, "c:\Name.ini", "General", "", "", "")  -        [General]
' Section = ReadINI(2, "c:\Name.ini", "Configuration", "", "", "")  -    [Configuration] 
' ListSection = Call ReadINI(3, "%WINDIR%\Name.ini", "", "", "", "")  -        
' ListKey = ReadINI(4, "c:\Name.ini", "Layout", "", "0", "")  -     ,    0   [Layout]
' ListKey = ReadINI(40, "c:\Name.ini", "Extensions", "", "Progr,Res,Plug", "")  -           [Extensions].    ,      Progr  Res  Plug
' Key = ReadINI(41, "c:\Name.ini", "Layout", "", "0", "") -  1- ,   0   [Layout]
' ...
' Key = ReadINI(60, "c:\Name.ini", "Layout", "", "0", "") -  20- ,   0   [Layout]
'=======================================================================
Function ReadINI(rn, rFileName, rSection, rKey, rValue, rDefault)
  rrText = ""
  If Len(rDefault) = 0 Then rDefault = "ErrorInI"
  ReadINI=rDefault 
  If Len(rFileName) = 0 Or Len(rn) = 0 Then Exit Function
  inirText = ReadINITextFile(rFileName)

  If Len(inirText) = 0 Then Exit Function
  If rn = 3 Or rn = 31 Then
    rrSplit = vbNewLine & "["
    If Left(inirText, 1) = "[" Then inirText = Mid(inirText, 2)
    If InStr(inirText, rrSplit) > 0 Then
      riniTxt = Split(inirText, rrSplit)
      For rrr = 0 To Ubound(riniTxt)
        rrText = rrText & "[" & Left(riniTxt(rrr),InStr(riniTxt(rrr), "]")) & vbNewLine
      Next
    Else
      If InStr(inirText, "]") > 0 Then rrText = Left(inirText, InStr(inirText, "]"))
    End If
    If rn = 31 Then
      rrText = Replace(rrText, "[", "")
      rrText = Replace(rrText, "]", "")
    End If
  Else
    If Len(rSection) = 0 Then Exit Function
    rrText = SectionText(inirText, rSection)
    If Len(rrText) = 0 Then Exit Function
    Select Case rn
      Case 1
        ReadINI = RegExpReplace(RegExpSearchInText(vbNewLine & rrText & vbNewLine, "\n" & rKey & "=.*\r\n"), "(\n.*=)(.*)(\r\n)", "$2")
        Exit Function
      Case 2
        ReadINI = rrText
        Exit Function
      Case 21
        ReadINI = "[" & rSection & "]" & vbNewLine & rrText
        Exit Function
      Case Else
        rrText = Replace(rrText, vbLf, vbNewLine)
        rrTxt = Split(rrText, vbNewLine)
        rrText = ""
        For rrr = 0 To Ubound(rrTxt)
          rInStr = InStr(rrTxt(rrr), "=")
          If Len(rrTxt(rrr)) > 0 And rInStr > 0 Then
            rrTxt(rrr) = RegExpReplace(rrTxt(rrr), "(\r)+", "")
            rsKey = Left(rrTxt(rrr), rInStr - 1)
            rsValue = Mid(rrTxt(rrr), rInStr + 1)
            rsStr = ""
            Select Case rn
              Case 10
                If LCase(rsKey) = LCase(rKey) Then 
                  ReadINI = rrTxt(rrr)
                  Exit Function
                Else
                  If rrr = Ubound(rrTxt) Then Exit Function
                End If
              Case 4
                If LCase(rsValue) = LCase(rValue) Then rsStr = rsKey
              Case 11,12
                If InStrLine(rKey, rsKey) = 1 Then
                  If  rn = 11 Then
                    rsStr = rsKey
                  Else
                    rsStr = rrTxt(rrr)
                  End If
                End If
              Case 13,14
                If Len(rsValue) > 0 Then
                  If  rn = 13 Then
                    rsStr = rsKey
                  Else
                    rsStr = rrTxt(rrr)
                  End If
                End If
              Case 15
                    rsStr = rsKey
              Case 16
                    rsStr = rrTxt(rrr)
              Case 17
                If Len(rsValue) = 0 Then rsStr = rsKey
              Case 40
                If InStrLine(rValue, rsValue) = 1 Then rsStr = rrTxt(rrr)
            End Select
            If  rn > 40 Then
              If LCase(rsValue) = LCase(rValue) Then rsStr = rsKey
            End If
            If Len(rsStr) > 0 Then rrText = rrText & rsStr & vbNewLine
          End If
        Next
        If  rn > 40 Then
          If Len(rrText) > 0 And InStr(rrText, vbNewLine) Then
            rvTxt = Split(rrText, vbNewLine)
            If rn - 40 < Ubound(rvTxt) Then
              rrText = rvTxt(rn - 41)
            Else
              Exit Function
            End If
          End If
        End If
    End Select
  End If
  If Len(rrText) = 0 Then Exit Function
  If Right(rrText, Len(vbNewLine)) = vbNewLine Then rrText = Left(rrText, Len(rrText) - Len(vbNewLine))
  ReadINI = RegExpReplace(rrText, "(\r)+", "$1")
End Function

'====================      =================================
' WriteINI(n, FileName, [Section], [Key], [Value], [Default])
'        INI
'=======================     =====================================
' 1- : n -  .   :
'        1   -      Key  Value   [Section] (     ,    )
'        10 -      Value   Key   [Section] (    ,      )
'        11 -      Value       [Section].    , e     ,    Key = "1,2,3..."
'        13 -    Value  ,     [Section]
'        15 -    Value     [Section]
'        17 -    Value   ,      Section (.. ,   )
'        2   -       [Section],   Key =     
'        3   -      Value   Key    .    , e     ,    Section = "1,2,3..."
' 2- : FileName  -  \_.ini (   )
'                                               -     ini  ( ,   )
' 3- : Section  -     INI 
' 4- : Key  -    
' 5- : Value  -   
' 6- : Default  -  ,   , :
'                            -   
'                            -    
'                            -   
'                            -    
'=======================    =====================================
'   [Default]  "ErrorInI",    
'   1 ,   
'========================        ======================================
' Call WriteINI(1, "c:\Name.ini", "Lister", "Caret", "", "") -     "Caret"  ""   "Lister"
' Result = WriteINI(1, "c:\Name.ini", "Lister", "Caret", "", "") -  "",      ,  1,   
' Call WriteINI(11, "c:\Name.ini", "Config", "Font,Rename,Size", "All", "") -      "Caret"  "All"   "Config",    , e     ,    "Font,Rename,Size"
' Result = WriteINI(11, "c:\Name.ini", "Config", "Font,Rename,Size", "All", "Error") -  "",    , 1 -  
' WriteINI(2, FileName, "Config", TextWithKeyAndValue, "", "")
' ...
'=======================================================================

Function WriteINI(wn, wFileName, wSection, wKey, wValue, wDefault)
  rrText = ""
  If Len(wDefault) = 0 Then wDefault = "ErrorInI"
  WriteINI=wDefault
  If Len(wFileName) = 0  Or Len(wn) = 0 And Len(wKey) = 0 Then Exit Function
  iniwText = ReadINITextFile(wFileName)
  If iniwText = "OpenError" Then Exit Function
  wlt = Len(iniwText)
  
  If wn = 3 Then
    If wlt = 0 And Len(wValue) = 0 Then Exit Function
    wSec = ReadINI(31, iniwText, "", "", "", "")
    If Len(wSec) = 0 Then Exit Function
    If InStr(wSec, vbNewLine) = 0 Then wSec = wSec & vbNewLine
    wS = Split(wSec, vbNewLine)
    For w = 0 To Ubound(wS)
      If InStrLine(wS(w), wSection) = 1 Then WriteINI = WriteINI(10, wFileName, wS(w), wKey, wValue, wDefault)
    Next
    Exit Function
  Else
    If Len(wSection) = 0 Then Exit Function
    wNameSec = "[" & wSection & "]"
    If InStr(iniwText, wNameSec) = 0 Then
      If wlt > 0 Then
        iniwText = iniwText & wNameSec & vbNewLine
      Else
         iniwText = wNameSec & vbNewLine
      End If
    End If
    wFullSection = ReadINI(21, iniwText, wSection, "", "", "")
    If wn = 2 Then
      WriteText = wNameSec & vbNewLine & wKey
      If wlt > 0 Then WriteText = vbNewLine & vbNewLine & WriteText
    Else
      Select Case wn
        Case 1, 10
          If InStr(LCase(wFullSection), LCase(vbNewLine & wKey & "=")) = 0 Then
            If wn = 1 Then Exit Function
            WriteText = wFullSection & vbNewLine & wKey & "=" & wValue
          Else
            WriteText = RegExpReplace(wFullSection, "(\n)" & wKey & "=.*", "$1" & wKey & "=" & wValue)
          End If
        Case 11, 13, 15, 17
          wListKey = ReadINI(wn, wFullSection, wSection, wKey, "", "wError")
          If wListKey = "wError" Then Exit Function
            WriteText = wFullSection
          If InStr(wListKey, vbNewLine) = 0 Then wListKey = wListKey & vbNewLine
          wK = Split(wListKey, vbNewLine)
          For w = 0 To Ubound(wK)
             WriteText = RegExpReplace(WriteText, "(\n)" & wK(w) & "=.*", "$1" & wK(w) & "=" & wValue)
          Next
      End Select
    End If
  End If

  iniwText = RegExpReplace(Replace(iniwText, wFullSection, WriteText), "(\r\n)+", "$1")
  iniwText = DelFirstEmptyLine(Replace(iniwText, "[", vbNewLine & "[", 1))
  If InStr(wFileName, vbNewLine) > 0 Then
    WriteINI = iniwText
  Else
    WriteINI = "1"
    Call FSO.OpenTextFile(wFileName, 2, False, -2).Write (iniwText)
  End If

End Function

'      ini 
Function SectionText(scText, scSection)
  scLine = "[" & scSection & "]" & vbNewLine
  nbsc = InStr(LCase(scText), LCase(scLine))
  ssText = ""
  If nbsc > 0 Then
    ssText = Mid(scText, nbsc + Len(scLine))
    nesc = InStr(ssText, vbNewLine & "[")
    If  nesc > 0 Then ssText = Left(ssText, nesc - 1)
  End If
   SectionText = RegExpReplace(ssText, "(\r)+", "$1") '   
End Function

'       
Function GetPath(pPath)
  GetPath = CreateObject("Scripting.FileSystemObject").GetAbsolutePathName(CreateObject("WScript.Shell").ExpandEnvironmentStrings(pPath))
End Function

' arrLine - ,         
'           arrLine = "1,2,3..."
'  1,         inLine, 0 -   
Function InStrLine(arrLine, inLine)
  InStrLine = 0
  iniArr = Split(arrLine,",")
  For lll = 0 To Ubound(iniArr)
    If InStr(LCase(inLine), LCase(iniArr(lll))) > 0 Then
      InStrLine = 1
      Exit For
    End If
  Next
End Function

'      
'  (,   ,   )
Function RegExpReplace(pText, pFindStr, pNewStr)
  With New RegExp
    .Pattern = pFindStr
    .IgnoreCase = True
    .Global = True
    RegExpReplace = .Replace(pText, pNewStr)
  End With
End Function

'      
'  (,   )
Function RegExpSearchInText(SeachText, pFindStr)
  With New RegExp
    .Pattern = pFindStr
    .Global = True
    .Multiline = True
    .IgnoreCase = True
    Set Matches = .Execute(SeachText)
    If Matches.Count > 0 Then RegExpSearchInText = Matches.Item(0)
    Set Matches = Nothing
  End With
End Function

'   INI  (   INI )
Function ReadINITextFile(FileINI)
  ReadINITextFile = "OpenError"
  If InStr(FileINI, vbNewLine) > 0 Then '  FileINI  
    ReadINITextFile = FileINI
  Else
    If InStr(FileINI, "%") > 0 Then FileINI = GetPath(FileINI)
      If Not FSO.FileExists(FileINI) Then Exit Function
      On Error Resume Next
      ReadINITextFile = FSO.OpenTextFile(FileINI, 1, False, -2).ReadAll
  End If
End Function

'    ,  \ 
Function DelFirstEmptyLine(InText)
  For iii = 1 To Len(InText)
    If Left(InText, Len(vbNewLine)) = vbNewLine Then
       InText = Right(InText, Len(InText) - Len(vbNewLine))
    Else
      Exit For
    End If
  Next
  DelFirstEmptyLine = InText
End Function