/// Multi_SR.js
/// http://tc-image.3dn.ru/forum/9-327-1044-16-1333391134
// (c) cnnnc
// version: 1.0 (04.08.2010) +10mod 27.11.2016  
///      
//  Multi SearchReplace without Argument(s).
//  Single SearchReplace with Argument(s).
//
//  Come by offical "SearchReplace.js" and "InsertFile.js", and others js. Thanks!
//
//  Multi SearchReplace:
//    Use pattern file to handle file(s).
//    Format of pattern file as following:
//      (bSensitive)\t(bMultiline)\t(bEscSequences)\t(bReplaceFunction)\t(nDirection)\t(nButton)\t(pFindIt)\t(pReplaceWith)
//
//      Example:
//        0       0       0       0       4       3       Notepad.exe     AkelPad.exe
//
//    Note: \\ -  
//          \r - line feed
//          \n -  
//          \t - 
//
//     bSensitive                 value: 0(false, default) or 1(ture)
//     bMultiline                 value: 0(false, default) or 1(ture)
//     bEscSequences              value: 0(false, default) or 1(ture)
//     bReplaceFunction           value: 0(false, default) or 1(ture, bEscSequences will be set to false)
//     nDirection                 value: 1  /* DN_DOWN      =0x00000001 */
//                                       2  /* DN_UP        =0x00000002 */
//                                       4  /* DN_BEGINNING =0x00000004 */ (default)
//                                       8  /* DN_SELECTION =0x00000008 */
//                                       16 /* DN_ALLFILES  =0x00000010 */
//     nButton                    value: 2 /* BT_REPLACE    =2 */
//                                       3 /* BT_REPLACEALL =3 */ (default)
//     pFindIt                    Should not be Empty
//     pReplaceWith               Should not be equal to "pFindIt"
//
//  Single SearchReplace:
/// (       #select#,  #select#    )
/// (       #bufer#,  #bufer#      )
/// (        ,     '')
/// 1.pFindIt -  
/// 2.pReplaceWith -  
///      ''
/// 3.bSensitive -  
/// 4.bMultiline - 
/// 5.bEscSequences - Esc-
/// 6.bReplaceFunction -   
/// 7.nDirection
/// 		1 - 
/// 		2 - 
/// 		4 -  
/// 		8 -  
/// 		16 -    
///   x -  ,    ,     ( )
/// 8.nButt
/// 		2 - 
/// 		3 -  
//    Call("Scripts::Main", 1, "multi_sr.js", `pFindIt pReplaceWith bSensitive bMultiline bEscSequences bReplaceFunction nDirection nButton`)
//
//    Example:
//      -"DelEmptyLines" Call("Scripts::Main", 1, "Multi_SR.js", `"(\n)+" "$1"`) Icon(0)
// 9.  

/// -"  " Call("Scripts::Main", 1, "Multi_SR.js", `"(\n)+" "$1"`) Icon("%a\AkelPadImage.dll",323)
/// -" " Call("Scripts::Main", 1, "Multi_SR.js", `"(\t)+" ""`) Icon("%a\AkelPadImage.dll",323)

if (AkelPad.GetEditWnd() == 0) WScript.Quit(); //      (26.04.2012)
//Options
var pFilter="Text files (*.txt)\x00*.txt\x00All Files (*.*)\x00*.*\x00\x00";
var nFilterIndex=2;

//Variables
var hMainWnd=AkelPad.GetMainWnd();
var pInitialFile=AkelPad.GetEditFile(0);
var pFile;

var oSys=AkelPad.SystemFunction();
var pScriptName=WScript.ScriptName;
var bAkelEdit=AkelPad.IsAkelEdit();

var pReplaceWithEsc;
var nSelStart;
var nSelEnd;
var nSearchResult;
var i;
var sArguments=WScript.Arguments.Length;

var poz;

//Buttons
var BT_FINDNEXT   =1
var BT_REPLACE    =2
var BT_REPLACEALL =3

//Direction
var DN_DOWN      =0x00000001
var DN_UP        =0x00000002
var DN_BEGINNING =0x00000004
var DN_SELECTION =0x00000008
var DN_ALLFILES  =0x00000010

if (hMainWnd)
{
  var bSensitive        =0;
  var bMultiline        =0;
  var bEscSequences     =0;
  var bReplaceFunction  =0;
  var nDirection        =DN_BEGINNING;
  var nButton           =BT_REPLACEALL;
  
  if (sArguments > 0)
  {
    var pFindIt=WScript.Arguments(0);
    pFindIt=pFindIt.replace(/''/g, '"'); //      (01.09.2012)
    pFindIt=pFindIt.replace(/#bufer#/g, AkelPad.GetClipboardText())
    // sr=AkelPad.GetSelText().replace(/\\/g,'.').replace(/(\?|\||\)|\(|\$|\^|\*|\+|\.|\[|\]|\:|\\)/g,'\\$1')
    sr=AkelPad.GetSelText().replace(/(\?|\||\)|\(|\$|\^|\*|\+|\.|\[|\]|\:|\\)/g,'\\$1')
// AkelPad.MessageBox(0," =>" + sr + "<=", " sr", 64);
    pFindIt=pFindIt.replace(/#select#/g,sr) // (21.11.2012)
    switch (sArguments)
    {
      case 9:
      pFindIt=pFindIt.replace(/([][$^.{}()+\\:])/g, '\\$1')
// AkelPad.MessageBox(0," =>" + pFindIt + "<=", " pFindIt", 64);
      case 8:
      nButton=WScript.Arguments(7);
      case 7:
        nDirection=WScript.Arguments(6);
         //     (18.10.2014)
        if (nDirection == 'x') nDirection= (AkelPad.GetSelText(3)=="") ? DN_BEGINNING : DN_SELECTION
      case 6:
        bReplaceFunction=WScript.Arguments(5);
      case 5:
        bEscSequences=WScript.Arguments(4);
      case 4:
        bMultiline=WScript.Arguments(3);
      case 3:
        bSensitive=WScript.Arguments(2);
      case 2:
        var pReplaceWith=WScript.Arguments(1);
        pReplaceWith=pReplaceWith.replace(/#bufer#/g, AkelPad.GetClipboardText()) //      (17.10.2012)
        pReplaceWith=pReplaceWith.replace(/#select#/g, AkelPad.GetSelText()) //      (21.11.2012)
        pReplaceWith=pReplaceWith.replace(/''/g, '"'); //      (01.09.2012)
        break;
      case 1:
        var pReplaceWith="";
    }
    SearchReplaceIt();
  }
  else
  {
    pFile=FileDialog(true, hMainWnd, pInitialFile, pFilter, nFilterIndex);

    if (pFile)
    {
      var OD_ADT_BINARY_ERROR    =1
      var OD_ADT_REG_CODEPAGE    =2
      var OD_ADT_DETECT_CODEPAGE =4
      var OD_ADT_DETECT_BOM      =8

      var nFlags=OD_ADT_BINARY_ERROR|OD_ADT_DETECT_CODEPAGE|OD_ADT_DETECT_BOM;
      var nCodePage=0;
      var nBOM=0;
      var pText;

      if (pText=AkelPad.ReadFile(pFile, nFlags, nCodePage, nBOM))
      {
        pText=pText.replace(/\r\n|\r|\n/g, "\r");
        var pLinesArray   =pText.split("\r");
        var nIndex        =-1;
        while (++nIndex < pLinesArray.length)
        {
          pLineText=pLinesArray[nIndex];
          var pStringsArray=pLineText.split("\t");

          var bSensitive        =pStringsArray[0];
          var bMultiline        =pStringsArray[1];
          var bEscSequences     =pStringsArray[2];
          var bReplaceFunction  =pStringsArray[3];
          var nDirection        =pStringsArray[4];
          var nButton           =pStringsArray[5];
          var pFindIt           =pStringsArray[6];
          var pReplaceWith      =pStringsArray[7];

          SearchReplaceIt();
        }
      }
    }
  }
}
if (! AkelPad.Include("FunctionsSave.js")) WScript.Quit(); 
SaveEditFile(); //      (17.12.2012)

//Functions
function FileDialog(bOpenTrueSaveFalse, hWnd, pInitialFile, pFilter, nFilterIndex)
{
  var nFlags=0x880804; //OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_EXPLORER|OFN_ENABLESIZING
  var pDefaultExt="txt";
  var lpStructure;
  var lpFilterBuffer;
  var lpFileBuffer;
  var lpExtBuffer;
  var oSys;
  var pResultFile="";
  var nCallResult;

  if (lpFilterBuffer=AkelPad.MemAlloc(256 * _TSIZE))
  {
    AkelPad.MemCopy(lpFilterBuffer, pFilter.substr(0, 255), _TSTR);

    if (lpFileBuffer=AkelPad.MemAlloc(256 * _TSIZE))
    {
      AkelPad.MemCopy(lpFileBuffer, pInitialFile.substr(0, 255), _TSTR);

      if (lpExtBuffer=AkelPad.MemAlloc(256 * _TSIZE))
      {
        AkelPad.MemCopy(lpExtBuffer, pDefaultExt.substr(0, 255), _TSTR);

        if (lpStructure=AkelPad.MemAlloc(76))  //sizeof(OPENFILENAMEA) or sizeof(OPENFILENAMEW)
        {
          //Fill structure
          AkelPad.MemCopy(lpStructure, 76, 3 /*DT_DWORD*/);                   //lStructSize
          AkelPad.MemCopy(lpStructure + 4, hWnd, 3 /*DT_DWORD*/);             //hwndOwner
          AkelPad.MemCopy(lpStructure + 12, lpFilterBuffer, 3 /*DT_DWORD*/);  //lpstrFilter
          AkelPad.MemCopy(lpStructure + 24, nFilterIndex, 3 /*DT_DWORD*/);    //nFilterIndex
          AkelPad.MemCopy(lpStructure + 28, lpFileBuffer, 3 /*DT_DWORD*/);    //lpstrFile
          AkelPad.MemCopy(lpStructure + 32, 256, 3 /*DT_DWORD*/);             //nMaxFile
          AkelPad.MemCopy(lpStructure + 52, nFlags, 3 /*DT_DWORD*/);          //Flags
          AkelPad.MemCopy(lpStructure + 60, lpExtBuffer, 3 /*DT_DWORD*/);     //lpstrDefExt

          if (oSys=AkelPad.SystemFunction())
          {
            //Call dialog
            if (bOpenTrueSaveFalse == true)
              nCallResult=oSys.Call("comdlg32::GetOpenFileName" + _TCHAR, lpStructure);
            else
              nCallResult=oSys.Call("comdlg32::GetSaveFileName" + _TCHAR, lpStructure);

            //Result file
            if (nCallResult) pResultFile=AkelPad.MemRead(lpFileBuffer, _TSTR);
          }
          AkelPad.MemFree(lpStructure);
        }
        AkelPad.MemFree(lpExtBuffer);
      }
      AkelPad.MemFree(lpFileBuffer);
    }
    AkelPad.MemFree(lpFilterBuffer);
  }
  return pResultFile;
}

function SearchReplaceIt()
{
  if (pFindIt=="") WScript.Quit();
  if (pReplaceWith==pFindIt) WScript.Quit();
  if (nButton==BT_REPLACE || nButton==BT_REPLACEALL)
  {
  }
  else
  {
    nButton=BT_REPLACEALL;
  }
  if (bSensitive != 1) bSensitive=0;
  if (bMultiline != 1) bMultiline=0;
  if (bEscSequences != 1) bEscSequences=0;
  if (bReplaceFunction != 1)
  {
    bReplaceFunction=0;
  }
  else
  {
    bEscSequences=0;
  }
  if (nDirection==DN_DOWN || nDirection==DN_UP || nDirection==DN_BEGINNING || nDirection==DN_SELECTION || nDirection==DN_ALLFILES)
  {
  }
  else
  {
    nDirection=DN_BEGINNING;
  }

  pReplaceWithEsc=pReplaceWith;
  if (bReplaceFunction)
  {
    //Replace with function
    if (!/(^|[^\w.])return\s+\S/.test(pReplaceWithEsc))
    pReplaceWithEsc="return " + pReplaceWithEsc;
    pReplaceWithEsc='var args={}, l=arguments.length;'
                  + 'for (var i=0; i < l; ++i)\n'
                  + '  args["$" + i]=arguments[i];\n'
                  + 'args.offset=arguments[l - 2];\n'
                  + 'args.s=arguments[l - 1];\n'
                  + 'with (args)\n'
                  + '{\n'
                  +    pReplaceWithEsc
                  + '\n}';
    pReplaceWithEsc=new Function(pReplaceWithEsc);
  }
  else if (bEscSequences)
  {
    //Esc-sequences
    pReplaceWithEsc=pReplaceWithEsc.replace(/\\\\/g, "\0");
    if (pReplaceWithEsc.search(/\\[^rnt]/g) != -1)
    {
      AkelPad.MessageBox(0, GetLangString(STRID_SYNTAXERROR), pScriptName, 16 /*MB_ICONERROR*/);
      WScript.Quit();
    }
    pReplaceWithEsc=pReplaceWithEsc.replace(/\\r\\n|\\r|\\n/g, "\n");
    pReplaceWithEsc=pReplaceWithEsc.replace(/\\t/g, "\t");
    pReplaceWithEsc=pReplaceWithEsc.replace(/\0/g, "\\");
  }

  nSearchResult=SearchReplace();
  if (nSearchResult == -1)
  {
    if (nDirection & DN_ALLFILES)
    {
      nDirection&=~DN_DOWN;
    }
    else if (nDirection & DN_BEGINNING)
    {
      nDirection&=~DN_DOWN;
    }
  }
  else
  {
    if (nDirection == DN_ALLFILES)
    {
      nDirection|=DN_DOWN;
    }
    else if (nDirection == DN_BEGINNING)
    {
      nDirection|=DN_DOWN;
    }
  }
}

function SearchReplace()
{
  var hWndFrameInit=AkelPad.SendMessage(hMainWnd, 1288 /*AKD_FRAMEFIND*/, 1 /*FWF_CURRENT*/, 0);
  var hWndCurrentEdit=AkelPad.GetEditWnd();
  var oPattern;
  var lpArray;
  var pSelText;
  var pResult;
  var nInitialSelStart;
  var nInitialSelEnd;
  var nSelStart;
  var nSelEnd;
  var lpInitialScroll;
  var nMatches=-1;
  var nChanges=0;
  var nChangedFiles=0;
  var nError;
  var nResult=-1;
  var i;

  oPattern=new RegExp(pFindIt, (bSensitive?"":"i") + (nButton == BT_REPLACEALL || nDirection & DN_UP?"g":"") + (bMultiline?"m":""));

  while (1)
  {
    nInitialSelStart=AkelPad.GetSelStart();
    nInitialSelEnd=AkelPad.GetSelEnd();

    if (nButton == BT_REPLACE)
    {
      if (nInitialSelStart != nInitialSelEnd)
      {
        pSelText=AkelPad.GetSelText(2 /*\n*/);
        if (!bAkelEdit)
          pSelText=pSelText.replace(/\r/g, "\n");

        if (lpArray=pSelText.match(oPattern))
        {
          if (lpArray.index == 0 && lpArray[0].length == (nInitialSelEnd - nInitialSelStart))
          {
            pResult=pSelText.replace(oPattern, pReplaceWithEsc);
            AkelPad.ReplaceSel(pResult);

            nInitialSelStart=AkelPad.GetSelStart();
            nInitialSelEnd=AkelPad.GetSelEnd();
          }
        }
      }
      nButton=BT_FINDNEXT;
    }

    if (nDirection & DN_DOWN)
    {
      if (nButton == BT_FINDNEXT)
      {
        nSelStart=nInitialSelEnd;
        nSelEnd=-1;
      }
      else
      {
        nSelStart=nInitialSelStart;
        nSelEnd=-1;
      }
    }
    else if (nDirection & DN_UP)
    {
      if (nButton == BT_FINDNEXT)
      {
        nSelStart=0;
        nSelEnd=nInitialSelStart;
      }
      else
      {
        nSelStart=0;
        nSelEnd=nInitialSelEnd;
      }
    }
    else if (nDirection & DN_BEGINNING)
    {
      nSelStart=0;
      nSelEnd=-1;
    }
    else if (nDirection & DN_SELECTION)
    {
      nSelStart=nInitialSelStart;
      nSelEnd=nInitialSelEnd;
    }
    else if (nDirection & DN_ALLFILES)
    {
      nSelStart=0;
      nSelEnd=-1;
    }
    lpInitialScroll=SaveScroll(hWndCurrentEdit);
    SetRedraw(hWndCurrentEdit, false);

    try
    {
      if (bAkelEdit) ScrollLock(hWndCurrentEdit, true);

      if (nSelStart != nInitialSelStart || nSelEnd != nInitialSelEnd)
      {
        AkelPad.SetSel(nSelStart, nSelEnd);
        nSelStart=AkelPad.GetSelStart();
        nSelEnd=AkelPad.GetSelEnd();
      }
      pSelText=AkelPad.GetSelText(2 /*\n*/);
      if (!bAkelEdit)
        pSelText=pSelText.replace(/\r/g, "\n");

      if (bAkelEdit) ScrollLock(hWndCurrentEdit, false);

      if (nButton == BT_FINDNEXT)
      {
        if (lpArray=pSelText.match(oPattern))
        {
          if (bAkelEdit) ScrollLock(hWndCurrentEdit, true);

          if (nDirection & DN_UP)
          {
            for (i=0; lpArray[i]; ++i);
            AkelPad.SetSel(nSelStart + (lpArray.lastIndex - lpArray[i - 1].length), nSelStart + lpArray.lastIndex);
          }
          else
          {
            AkelPad.SetSel(nSelStart + lpArray.index, nSelStart + lpArray.index + lpArray[0].length);
          }

          if (bAkelEdit)
          {
            ScrollLock(hWndCurrentEdit, false);
            ScrollCaret(hWndCurrentEdit);
          }
          SetRedraw(hWndCurrentEdit, true);
          nResult=AkelPad.GetSelStart();
        }
        else
        {
          AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);
          RestoreScroll(hWndCurrentEdit, lpInitialScroll);
          SetRedraw(hWndCurrentEdit, true);

          if (nDirection & DN_ALLFILES)
          {
            //Next MDI frame
            AkelPad.SendMessage(hMainWnd, 273 /*WM_COMMAND*/, 4316 /*IDM_WINDOW_FRAMENEXT*/, 0);
            hWndCurrentEdit=AkelPad.GetEditWnd();
            if (hWndFrameInit != AkelPad.SendMessage(hMainWnd, 1288 /*AKD_FRAMEFIND*/, 1 /*FWF_CURRENT*/, 0))
            {
              AkelPad.SetSel(0, 0);
              continue;
            }
          }
        }
      }
      else if (nButton == BT_REPLACEALL)
      {
        if (nMatches)
        {
          pResult=pSelText.replace(oPattern, pReplaceWithEsc);

          if (bAkelEdit)
          {
            if (nDirection & DN_SELECTION)
            {
              dwOptions=AkelPad.SendMessage(hWndCurrentEdit, 3227 /*AEM_GETOPTIONS*/, 0, 0);
              if (!(dwOptions & 0x40 /*AECO_PASTESELECTCOLUMN*/))
                AkelPad.SendMessage(hWndCurrentEdit, 3228 /*AEM_SETOPTIONS*/, 2 /*AECOOP_OR*/, 0x40 /*AECO_PASTESELECTCOLUMN*/);
            }
          }

          //Replace selection
          AkelPad.ReplaceSel(pResult);

          if (bAkelEdit)
          {
            if (nDirection & DN_SELECTION)
            {
              if (!(dwOptions & 0x40 /*AECO_PASTESELECTCOLUMN*/))
                AkelPad.SendMessage(hWndCurrentEdit, 3228 /*AEM_SETOPTIONS*/, 4 /*AECOOP_XOR*/, 0x40 /*AECO_PASTESELECTCOLUMN*/);
            }
          }

          if (nDirection & DN_SELECTION)
          {
            if (!AkelPad.SendMessage(hWndCurrentEdit, 3127 /*AEM_GETCOLUMNSEL*/, 0, 0))
              AkelPad.SetSel(nSelStart, nSelStart + pResult.length);
          }
          else AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);
        }
        else AkelPad.SetSel(nInitialSelStart, nInitialSelEnd);

        RestoreScroll(hWndCurrentEdit, lpInitialScroll);
        SetRedraw(hWndCurrentEdit, true);

        if (nDirection & DN_ALLFILES)
        {
          //Next MDI frame
          AkelPad.SendMessage(hMainWnd, 273 /*WM_COMMAND*/, 4316 /*IDM_WINDOW_FRAMENEXT*/, 0);
          hWndCurrentEdit=AkelPad.GetEditWnd();
          if (hWndFrameInit != AkelPad.SendMessage(hMainWnd, 1288 /*AKD_FRAMEFIND*/, 1 /*FWF_CURRENT*/, 0))
          {
            AkelPad.SetSel(0, 0);
            continue;
          }
        }
      }
    }
    catch (nError)
    {
      RestoreScroll(hWndCurrentEdit, lpInitialScroll);
      SetRedraw(hWndCurrentEdit, true);
      AkelPad.MessageBox(0, nError.description, pScriptName, 16 /*MB_ICONERROR*/);
    }
    break;
  }
  return nResult;
}

//Functions
function SetRedraw(hWnd, bRedraw)
{
  AkelPad.SendMessage(hWnd, 11 /*WM_SETREDRAW*/, bRedraw, 0);
  if (bRedraw) oSys.Call("user32::InvalidateRect", hWnd, 0, true);
}

function SaveScroll(hWnd)
{
  var lpPoint;

  if (lpPoint=AkelPad.MemAlloc(8 /*sizeof(POINT)*/))
    AkelPad.SendMessage(hWnd, 1245 /*EM_GETSCROLLPOS*/, 0, lpPoint);
  return lpPoint;
}

function RestoreScroll(hWnd, lpPoint)
{
  AkelPad.SendMessage(hWnd, 1246 /*EM_SETSCROLLPOS*/, 0, lpPoint);
  AkelPad.MemFree(lpPoint);
}

function ScrollLock(hWnd, bLock)
{
  AkelPad.SendMessage(hWnd, 3185 /*AEM_LOCKSCROLL*/, 3 /*SB_BOTH*/, bLock);
}

function ScrollCaret(hWnd)
{
  var lpStp;
  var dwScrollFlags=0;
  var dwScrollResult;

  if (lpStp=AkelPad.MemAlloc(20))  //sizeof(AESCROLLTOPOINT)
  {
    //Test scroll to caret
    dwScrollFlags=0x1|0x10|0x400|0x800 /*AESC_TEST|AESC_POINTCARET|AESC_OFFSETCHARX|AESC_OFFSETCHARY*/;
    AkelPad.MemCopy(lpStp, dwScrollFlags, 3 /*DT_DWORD*/);  //AESCROLLTOPOINT.dwFlags
    AkelPad.MemCopy(lpStp + 12, 1, 3 /*DT_DWORD*/);         //AESCROLLTOPOINT.nOffsetX
    AkelPad.MemCopy(lpStp + 16, 0, 3 /*DT_DWORD*/);         //AESCROLLTOPOINT.nOffsetY
    dwScrollResult=AkelPad.SendMessage(hWnd, 3183 /*AEM_SCROLLTOPOINT*/, 0, lpStp);

    dwScrollFlags=0x10 /*AESC_POINTCARET*/;
    if (dwScrollResult & 0x1 /*AECSE_SCROLLEDX*/)
      dwScrollFlags|=0x1000 /*AESC_OFFSETRECTDIVX*/;
    if (dwScrollResult & 0x2 /*AECSE_SCROLLEDY*/)
      dwScrollFlags|=0x2000 /*AESC_OFFSETRECTDIVY*/;

    //Scroll to caret
    AkelPad.MemCopy(lpStp, dwScrollFlags, 3 /*DT_DWORD*/);  //AESCROLLTOPOINT.dwFlags
    AkelPad.MemCopy(lpStp + 12, 3, 3 /*DT_DWORD*/);         //AESCROLLTOPOINT.nOffsetX
    AkelPad.MemCopy(lpStp + 16, 2, 3 /*DT_DWORD*/);         //AESCROLLTOPOINT.nOffsetY
    AkelPad.SendMessage(hWnd, 3183 /*AEM_SCROLLTOPOINT*/, 0, lpStp);

    AkelPad.MemFree(lpStp);
  }
}

function GetLangString(nStringID)
{
  var nLangID;

  nLangID=oSys.Call("kernel32::GetUserDefaultLangID");
  nLangID=nLangID & 0x3ff; //PRIMARYLANGID

  if (nLangID == 0x19) //LANG_RUSSIAN
  {
    if (nStringID == STRID_LOWJSCRIPT)
      return "\u0412\u0435\u0440\u0441\u0438\u044F\u0020\u004A\u0053\u0063\u0072\u0069\u0070\u0074\u0020\u043D\u0438\u0436\u0435\u002C\u0020\u0447\u0435\u043C\u0020\u0035\u002E\u0035\u002E";
    if (nStringID == STRID_SYNTAXERROR)
      return "\u0421\u0438\u043D\u0442\u0430\u043A\u0441\u0438\u0447\u0435\u0441\u043A\u0430\u044F\u0020\u043E\u0448\u0438\u0431\u043A\u0430\u003A\n \\\\ - \u043E\u0431\u0440\u0430\u0442\u043D\u044B\u0439\u0020\u0441\u043B\u044D\u0448\n \\r - \u043A\u043E\u043D\u0435\u0446\u0020\u0441\u0442\u0440\u043E\u043A\u0438\n \\t - \u0437\u043D\u0430\u043A\u0020\u0442\u0430\u0431\u0443\u043B\u044F\u0446\u0438\u0438";
  }
  else
  {
    if (nStringID == STRID_LOWJSCRIPT)
      return "JScript version is less than 5.5.";
    if (nStringID == STRID_SYNTAXERROR)
      return "Syntax error:\n \\\\ - backslash\n \\r - line feed\n \\t - tabulation";
  }
  return "";
}