/// SessionMenu.js
//  ============================================================================
//  http://akelpad.sourceforge.net/forum/viewtopic.php?p=30939#30939
//  Version: 2016-09-18
//  Author: Kley
//
//  Description(1033): Show menu with files specific session.
//  Description(1049):      .
//
//  Arguments:
//  -p=1           -    .
//                    0  -  ( );
//                    1  - ;
//                    2  -  SessionMenu.ini.
//  -s="name"      -     .
//                  (  ,  ).
//  -b="NoExist "  -      (  "* ").
//  -a="\t*"       -      (  "").
//  -e=1           -    (  0).
//                      :
//                      1  "" (\  Session);
//                      2  " ";
//                      4  " ";
//                      8  " ";
//                     16  " ";
//                     32  " ";
//                     64  " ";
//                    128    .
//  -es=62         -     (  0).
//                      :   -e.
//                 -e  -es ,    -s.
//  -sm=2          -      .
//                    0  -   ( );
//                    1  -  ;
//                    2  - ,    .
//
//  -m="%m"        -     
//  -i="%i"         (  !).
//
//  Usage:
//     ToolBar (  )
//   Call("Scripts::Main", 1, "SessionMenu.js")
//   ToolBar (  )
//   Call("Scripts::Main", 1, "SessionMenu.js", `-s="OnExit" -m="%m" -i="%i"`)
//
//  Note:
//     ,     -s.
//
//  ============================================================================
//  Include: ShowMenu.js (http://akelpad.sourceforge.net/en/plugins.php#Scripts)
//  ============================================================================
if (!AkelPad.Include("ShowMenu.js"))
  WScript.Quit();

var nShowPath = AkelPad.GetArgValue("p", 0);
var pSessionName = AkelPad.GetArgValue("s", "");
var pBeforeName = AkelPad.GetArgValue("b", "* ");
var pAfterName = AkelPad.GetArgValue("a", "");
var nExtraMenu = AkelPad.GetArgValue("e", 0);
var nExtraSubMenu = AkelPad.GetArgValue("es", 0);
var nSortMenu = AkelPad.GetArgValue("sm", 0);
var hToolbarHandle = AkelPad.GetArgValue("m", 0);
var nToolbarItemID = AkelPad.GetArgValue("i", 0);

var PARAM_DIALOG =   1;
var PARAM_OPEN   =   2;
var PARAM_SAVE   =   4;
var PARAM_CLOSE  =   8;
var PARAM_EDIT   =  16;
var PARAM_DELETE =  32;
var PARAM_NEW    =  64;
var PARAM_TOP    = 128;

//Variables
var oFSO = new ActiveXObject("Scripting.FileSystemObject");
var oSys = AkelPad.SystemFunction();
var pAkelPadDir = AkelPad.GetAkelDir(0 /*ADTYPE_ROOT*/);
var pSessionsDir = GetSessionsDir();
var aSessionsFile = []; //[Path, BaseName]
var aExtraMenu = [];
var aExtraSubMenu = [];
var aFilesMenu;
var aFinalMenu = [];
var nMenuItem = 0;
var ptPoint;
var nPointX = POS_CURSOR;
var nPointY = POS_CURSOR;
var bShowPath = (nShowPath == 2) ? true : false;
var i = 0;

if (AkelPad.IsMDI() == 0 /*WMD_SDI*/)
{
  if (!pSessionName)
    WScript.Quit();
}

if (pSessionsDir)
{
  if (hToolbarHandle && nToolbarItemID)
  {
    ptPoint = GetToolbarBottonPos(parseInt(hToolbarHandle), parseInt(nToolbarItemID));
    nPointX = ptPoint.x;
    nPointY = ptPoint.y;
  }
  pAfterName = pAfterName.replace(/\\t/g, "\t");

  GetLangStrings();

  if (nShowPath == 2)
    ReadIni();

  if (pSessionName)
  {
    aFinalMenu = GetFilesInSession(pSessionsDir + "\\" + pSessionName + ".session");

    if (!aFinalMenu.length)
    {
      if (!oFSO.FileExists(pSessionsDir + "\\" + pSessionName + ".session"))
        aFinalMenu = aFinalMenu.concat([[sEmpty, MF_DISABLED]], GetExtraSubMenu(pSessionName, PARAM_SAVE));
      else
        aFinalMenu = aFinalMenu.concat(
          [[sEmpty, MF_DISABLED]],
          [[sAddCurFile, MF_NORMAL, 9, pSessionsDir + "\\" + pSessionName + ".session"]],
          GetExtraSubMenu(pSessionName, PARAM_SAVE|PARAM_EDIT|PARAM_DELETE));
    }
  }
  else
  {
    aSessionsFile = GetSessionsFile(pSessionsDir)

    if (aSessionsFile.length)
    {
      for (var i = 0; i < aSessionsFile.length; ++i)
      {
        aFilesMenu = GetFilesInSession(aSessionsFile[i][0]);

        if (aFilesMenu.length)
          aExtraSubMenu = GetExtraSubMenu(aSessionsFile[i][1], nExtraSubMenu);
        else
          aExtraSubMenu = [[sEmpty, MF_DISABLED]].concat(
            [[sAddCurFile, MF_NORMAL, 9, aSessionsFile[i][0]]],
            GetExtraSubMenu(aSessionsFile[i][1], PARAM_SAVE|PARAM_EDIT|PARAM_DELETE));

        aFinalMenu = aFinalMenu.concat([[aSessionsFile[i][1], MF_SUBMENU]]);
        aFinalMenu = (nExtraSubMenu & PARAM_TOP) ? aFinalMenu.concat(aExtraSubMenu, aFilesMenu)
                                                 : aFinalMenu.concat(aFilesMenu, aExtraSubMenu);

        if (aFinalMenu.length)
          aFinalMenu[aFinalMenu.length - 1][1] |= MF_LAST;
      }

      aExtraMenu = GetExtraMenu(nExtraMenu);
      aFinalMenu = (nExtraMenu & PARAM_TOP) ? aExtraMenu.concat([["", MF_SEPARATOR]], aFinalMenu)
                                            : aFinalMenu.concat([["", MF_SEPARATOR]], aExtraMenu);
    }
    else
      aFinalMenu = [[sEmpty, MF_DISABLED], ["", MF_SEPARATOR], [sDialog, MF_NORMAL, 6]];
  }

  //Show menu
  if ((nMenuItem = ShowMenu(aFinalMenu, nPointX, nPointY)) != -1)
  {
    switch (aFinalMenu[nMenuItem][2])
    {
      case 1:
      case 2:
      case 3:
      case 4:
        AkelPad.Call("Sessions::Main", aFinalMenu[nMenuItem][2], aFinalMenu[nMenuItem][3]);
        break;
      case 5:
        if (AkelPad.MessageBox(AkelPad.GetMainWnd(), sMsgDelete.replace(/%s/, aFinalMenu[nMenuItem][3]),
              WScript.ScriptName, 292 /*MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2*/)
              == 6 /*IDYES*/)
          AkelPad.Call("Sessions::Main", 5, aFinalMenu[nMenuItem][3]);
        break;
      case 6:
        AkelPad.Call("Sessions::Main"); //open/close dialog
        break;
      case 7:
        RemoveNonExistFiles(aFinalMenu[nMenuItem][3]);
        break;
      case 8:
        nShowPath = !nShowPath;
        WriteIni();
        break;
      case 9:
        AddCurFileToSession(aFinalMenu[nMenuItem][3]);
        break;
      case 10:
        CreateNewSession();
        break;
      default:
        AkelPad.OpenFile(aFinalMenu[nMenuItem][3], 0x002 /*OD_ADT_REGCODEPAGE*/);
    }
  }
}

function GetSessionsFile(pSessionsDir)
{
  var oFolder = oFSO.GetFolder(pSessionsDir);
  var oFiles;
  var aSessions = [];

  for (oFiles = new Enumerator(oFolder.files); !oFiles.atEnd(); oFiles.moveNext())
  {
    if (oFSO.GetExtensionName(oFiles.item().Name).toLowerCase() == "session")
      aSessions.push([oFiles.item().Path, oFSO.GetBaseName(oFiles.item().Name)]);
  }

  if (aSessions)
  {
    //Sort array
    aSessions.sort(function(a, b)
    {
      return oSys.Call("kernel32::lstrcmpi" + _TCHAR, a[1], b[1]);
    });
  }

  return aSessions;
}

function GetFilesInSession(pSessionFile)
{
  var aFilesPath = [];
  var aFilesMenu = [];
  var pSessionText = "";
  var aSessionLines;
  var pPath;
  var pPrefix;
  var pSuffix;
  var bNonExist = false;
  var nIDMenu = 100;
  var i;

  if (oFSO.FileExists(pSessionFile))
  {
    if (pSessionText = AkelPad.ReadFile(pSessionFile))
    {
      pSessionText = pSessionText.replace(/\%a/gi, pAkelPadDir);
      pSessionText = pSessionText.replace(/(\r\n|\r|\n)/g, "\n");

      aSessionLines = pSessionText.split("\n");

      for (i = 0; i < aSessionLines.length; ++i)
      {
        if (aSessionLines[i].length)
        {
          if (aSessionLines[i].indexOf("\\") != -1)
          {
            pPath = aSessionLines[i].replace(/(^[ \t]*)|([ \t]*$)/mg, "");
            aFilesPath.push([pPath, oFSO.GetFileName(pPath)]);
          }
        }
      }

      //Sort array
      if (nSortMenu != 2)
      {
        if (nShowPath == 0)
        {
          aFilesPath.sort(function(a, b)
          {
            if (nSortMenu == 1)
              return oSys.Call("kernel32::lstrcmpiW", b[1], a[1]);
            else
              return oSys.Call("kernel32::lstrcmpiW", a[1], b[1]);
          });
        }
        else
        {
          aFilesPath.sort(function(a, b)
          {
            if (nSortMenu == 1)
              return oSys.Call("kernel32::lstrcmpiW", b[0], a[0]);
            else
              return oSys.Call("kernel32::lstrcmpiW", a[0], b[0]);
          });
        }
      }

      for (i = 0; i < aFilesPath.length; ++i)
      {
        pPrefix = "";
        pSuffix = "";

        if (!oFSO.FileExists(aFilesPath[i][0]))
        {
          pPrefix = pBeforeName;
          pSuffix = pAfterName;
          bNonExist = true;
        }

        pPath = (nShowPath) ? pPrefix + aFilesPath[i][0] + pSuffix
                            : pPrefix + aFilesPath[i][1] + pSuffix;

        aFilesMenu.push([pPath, MF_NORMAL, nIDMenu + i, aFilesPath[i][0]]);
      }

      aFilesMenu = aFilesMenu.concat([["", MF_SEPARATOR]]);

      if (bShowPath)
        aFilesMenu = (nShowPath) ? aFilesMenu.concat([[sShowPath, MF_CHECKED, 8]])
                                 : aFilesMenu.concat([[sShowPath, MF_NORMAL, 8]]);

      if (AkelPad.GetEditFile(0))
        aFilesMenu = aFilesMenu.concat([[sAddCurFile, MF_NORMAL, 9, pSessionFile]]);

      if (bNonExist)
        aFilesMenu = aFilesMenu.concat([[sNonExist, MF_NORMAL, 7, pSessionFile]]);
    }
  }
  return aFilesMenu;
}

function GetExtraSubMenu(pSessionBaseName, nFlags)
{
  var aMenuEdit = [];

  if (nFlags & PARAM_OPEN)
    aMenuEdit = aMenuEdit.concat([[sOpen,   MF_NORMAL, 1, pSessionBaseName]]);
  if (nFlags & PARAM_SAVE)
    aMenuEdit = aMenuEdit.concat([[sSave,   MF_NORMAL, 2, pSessionBaseName]]);
  if (nFlags & PARAM_CLOSE)
    aMenuEdit = aMenuEdit.concat([[sClose,  MF_NORMAL, 3, pSessionBaseName]]);
  if (nFlags & PARAM_EDIT)
    aMenuEdit = aMenuEdit.concat([[sEdit,   MF_NORMAL, 4, pSessionBaseName]]);
  if (nFlags & PARAM_DELETE)
    aMenuEdit = aMenuEdit.concat([[sDelete, MF_NORMAL, 5, pSessionBaseName]]);
  if (nFlags & PARAM_NEW)
    aMenuEdit = aMenuEdit.concat([[sCreate, MF_NORMAL, 10]]);
  if (nFlags & PARAM_DIALOG)
    aMenuEdit = aMenuEdit.concat([[sDialog, MF_NORMAL, 6]]);

  if (aMenuEdit.length)
    aMenuEdit = (nFlags & PARAM_TOP) ? aMenuEdit.concat([["", MF_SEPARATOR]])
                                     : [["", MF_SEPARATOR]].concat(aMenuEdit);
  return aMenuEdit;
}

function GetExtraMenu(nFlags)
{
  var aMenuEdit = [];

  if (nFlags & PARAM_OPEN)
    aMenuEdit = aMenuEdit.concat([[sOpen,   MF_SUBMENU]], GetSessionFiles(1));
  if (nFlags & PARAM_SAVE)
    aMenuEdit = aMenuEdit.concat([[sSave,   MF_SUBMENU]], GetSessionFiles(2));
  if (nFlags & PARAM_CLOSE)
    aMenuEdit = aMenuEdit.concat([[sClose,  MF_SUBMENU]], GetSessionFiles(3));
  if (nFlags & PARAM_EDIT)
    aMenuEdit = aMenuEdit.concat([[sEdit,   MF_SUBMENU]], GetSessionFiles(4));
  if (nFlags & PARAM_DELETE)
    aMenuEdit = aMenuEdit.concat([[sDelete, MF_SUBMENU]], GetSessionFiles(5));
  if (nFlags & PARAM_NEW)
    aMenuEdit = aMenuEdit.concat([[sCreate, MF_NORMAL, 10]]);
  if (nFlags & PARAM_DIALOG)
    aMenuEdit = aMenuEdit.concat([[sDialog, MF_NORMAL, 6]]);

  return aMenuEdit;
}

function GetSessionFiles(vIDMenu)
{
  var aSubMenu = [];

  for (var i = 0; i < aSessionsFile.length; ++i)
    aSubMenu.push([aSessionsFile[i][1], MF_NORMAL, vIDMenu, aSessionsFile[i][1]]);

  if (aSubMenu.length)
    aSubMenu[aSubMenu.length - 1][1] |= MF_LAST;

  return aSubMenu;
}

function AddCurFileToSession(pSessionFile)
{
  var pAkelDir;
  var pEditFile;
  var oSet;
  var bSaveRelative = 0;
  var pText;

  if (oFSO.FileExists(pSessionFile))
  {
    if (pEditFile = AkelPad.GetEditFile(0))
    {
      oSet = AkelPad.ScriptSettings();

      if (oSet.Begin("Sessions", 0x21 /*POB_READ|POB_PLUGS*/))
      {
        bSaveRelative = oSet.Read("SaveRelative", 1 /*PO_DWORD*/, 0);
        oSet.End();
      }

      if (bSaveRelative)
      {
        pAkelDir = pAkelPadDir.replace(/\\/g, "\\\\");
        pEditFile = pEditFile.replace(new RegExp(pAkelDir, "gi"), "%a");
      }

      pText = (AkelPad.ReadFile(pSessionFile) ? "\r\n" : "") +
              pEditFile + '\r\n' +
              '/Name="' + oFSO.GetFileName(pEditFile) + '" ' +
              '/Active=0 ' +
              '/Codepage=0 ' +
              '/Selection=0-0 ' +
              '/FirstVisChar=0 ' +
              '/WordWrap=0 ' +
              '/ReadOnly=0 ' +
              '/Overtype=0 ' +
              '/Bookmarks= ' +
              '/CoderAlias= ' +
              '/Folds= ' +
              '/Marks=\r\n';

      AkelPad.WriteFile(pSessionFile, pText, -1, 1200, true, 0x2 /*WFF_APPENDFILE*/);
    }
  }
}

function RemoveNonExistFiles(pSessionFile)
{
  var pSessionText;
  var aTextArray;
  var pLineText;
  var bNonExist = false;
  var bEmptyLine = false;
  var aNewText = [];

  if (oFSO.FileExists(pSessionFile))
  {
    if (pSessionText = AkelPad.ReadFile(pSessionFile))
    {
      pSessionText = pSessionText.replace(/(\r\n|\r|\n)/g, "\n");
      aTextArray = pSessionText.split("\n");

      for (var i = 0; i < aTextArray.length; ++i)
      {
        pLineText = aTextArray[i].replace(/(^[ \t]*)|([ \t]*$)/mg, "");

        if (pLineText.length > 0)
        {
          if (pLineText.indexOf("\\") != -1)
          {
            if (oFSO.FileExists(pLineText.replace(/\%a/i, pAkelPadDir)))
            {
              aNewText.push(aTextArray[i]);
              bNonExist = false;
              bEmptyLine = false;
            }
            else bNonExist = true;
          }
          else
          {
            if (bNonExist)
            {
              bNonExist = false;
              bEmptyLine = true;
            }
            else aNewText.push(aTextArray[i]);
          }
        }
        else
        {
          if (bEmptyLine) bEmptyLine = false;
          else  aNewText.push(aTextArray[i]);
        }
      }
    }
  }
  AkelPad.WriteFile(pSessionFile, aNewText.join("\r\n"), -1, 1200, true);
}

function CreateNewSession()
{
  var hMainWnd = AkelPad.GetMainWnd();
  var pSessionName = "";

  for (;;)
  {
    pSessionName = AkelPad.InputBox(hMainWnd, sCreate, sMsgNewName, pSessionName);

    if (pSessionName === undefined)
      break;

    if (pSessionName = pSessionName.replace(/[\\\/:\*\?"{}<>\|]/g, "_"))
    {

      if (!oFSO.FileExists(pSessionsDir + "\\" + pSessionName + ".session"))
      {
        AkelPad.Call("Sessions::Main", 2, pSessionName);
        break;
      }
      else
      {
        if (AkelPad.MessageBox(hMainWnd, sMsgExists.replace(/%s/, pSessionName),
              WScript.ScriptName, 292 /*MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2*/)
              == 6 /*MB_YES*/)
        {
          AkelPad.Call("Sessions::Main", 2, pSessionName);
          break;
        }
      }
    }
  }
}

function GetSessionsDir()
{
  var oSet = AkelPad.ScriptSettings();
  var nSaveSessions = 1 /*SDIR_PROGRAM*/;
  var lpBuffer;
  var pSessionsDir = "";

  if (oSet.Begin("Sessions", 0x21 /*POB_READ|POB_PLUGS*/))
  {
    nSaveSessions = oSet.Read("SaveSessions", 1 /*PO_DWORD*/);
    oSet.End();
  }
  if (nSaveSessions == 1 /*SDIR_PROGRAM*/)
    pSessionsDir = AkelPad.GetAkelDir(4 /*ADTYPE_PLUGS*/) + "\\Sessions";
  else if (nSaveSessions == 2 /*SDIR_APPDATA*/)
  {
    if (lpBuffer = AkelPad.MemAlloc(256 * _TSIZE))
    {
      oSys.Call("shell32::SHGetSpecialFolderPath" + _TCHAR, AkelPad.GetMainWnd(), lpBuffer, 0x1a /*CSIDL_APPDATA*/, 0);
      pSessionsDir = AkelPad.MemRead(lpBuffer, _TSTR) + "\\AkelPad\\Sessions";
      AkelPad.MemFree(lpBuffer);
    }
  }
  return pSessionsDir;
}

function ReadIni()
{
  var oSet = AkelPad.ScriptSettings();

  if (oSet.Begin("", 0x1 /*POB_READ*/))
  {
    nShowPath = oSet.Read("ShowPath", 1 /*PO_DWORD*/, 0);
    oSet.End();
  }
}

function WriteIni()
{
  var oSet = AkelPad.ScriptSettings();

  if (oSet.Begin("", 0x2 /*POB_SAVE*/))
  {
    oSet.Write("ShowPath", 1 /*PO_DWORD*/, nShowPath);
    oSet.End();
  }
}

function GetLangStrings()
{
  if (AkelPad.GetLangId(0 /*LANGID_FULL*/) == 1049 /*Russian*/)
  {
    sDialog     = "...";
    sOpen       = " ";
    sSave       = " ";
    sClose      = " ";
    sEdit       = " ";
    sCreate     = " ...";
    sDelete     = "  ...";
    sNonExist   = " ";
    sShowPath   = "  ";
    sAddCurFile = "  ";
    sEmpty      = "";
    sMsgNewName = " :";
    sMsgExists  = " \"%s\"  .  ?";
    sMsgDelete  = " ,     \"%s\"?";
  }
  else
  {
    sDialog     = "Dialog...";
    sOpen       = "Open session";
    sSave       = "Save session";
    sClose      = "Close session";
    sEdit       = "Edit session";
    sCreate     = "Create session...";
    sDelete     = "Delete session file...";
    sNonExist   = "Delete non-existent";
    sShowPath   = "Show files path";
    sAddCurFile = "Add current file";
    sEmpty      = "Empty";
    sMsgNewName = "New name:";
    sMsgExists  = "Session \"%s\" already exists. Overwrite it?";
    sMsgDelete  = "Are you sure you want to delete session \"%s\"?";
  }
}